`timescale 1ns/100ps
module clkrst(clkin,reset,clk2x, locked);
    input clkin;
    input reset;
    output clk2x;
    output locked;

wire  clk0, clkfb, clk2x_dcm, clk;

	BUFG   buf1 (.I ( clk0 ),   .O ( clkfb ));
	BUFG   buf2 (.I ( clk2x_dcm ),   .O ( clk2x ));

   DCM DCM_inst (
      .CLK0(clk0),     // 0 degree DCM CLK ouptput
      .CLK180(), // 180 degree DCM CLK output
      .CLK270(), // 270 degree DCM CLK output
      .CLK2X(clk2x_dcm),   // 2X DCM CLK output
      .CLK2X180(), // 2X, 180 degree DCM CLK out
      .CLK90(),   // 90 degree DCM CLK output
      .CLKDV(),   // Divided DCM CLK out (CLKDV_DIVIDE)
      .CLKFX(),   // DCM CLK synthesis out (M/D)
      .CLKFX180(), // 180 degree CLK synthesis out
      .LOCKED(locked), // DCM LOCK status output
      .PSDONE(), // Dynamic phase adjust done output
      .STATUS(), // 8-bit DCM status bits output
      .CLKFB(clkfb),   // DCM clock feedback
      .CLKIN(clkin),   // Clock input (from IBUFG, BUFG or DCM)
		.DSSEN(),
      .PSCLK(),   // Dynamic phase adjust clock input
      .PSEN(),     // Dynamic phase adjust enable input
      .PSINCDEC(), // Dynamic phase adjust increment/decrement
      .RST(reset)        // DCM asynchronous reset input
   );

			   
endmodule
