//-----------------------------------------------------------------------------
// code_gen_s2 - Module
//-----------------------------------------------------------------------------
//**************************************************************************
// 
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION \"AS IS\"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//**************************************************************************
//-----------------------------------------------------------------------------
// Filename:        code_gen_s2.v
//-----------------------------------------------------------------------------
// Description:
//      Top level design for 16-bit Multiple Error Detection and Correction.
//		  Further details can be found in XAPP715
//-----------------------------------------------------------------------------
//Structure:
//      --XAPP715_top.v
//        |--code_gen_s2.v
//        |--code_gen_s3.v
//        |--MLD_s1.v
//           |--MLD_adder_s1.v
//        |--MLD_s2.v
//           |--MLD_adder_s2.v
//        |--MLD_s3.v
//        |--ocs_gen_s1.v
//        |--ocs_gen_s2.v
//        |--encoder.v
//
//-----------------------------------------------------------------------------
// Owners:          Simon Tam 
// Revision 1.0
//
//     Modification History:                                                   
//     Date     Init          Description                                
//   --------  ------ ---------------------------------------------------------    
//   11/9/2004    STAM	    Initial Release 
//-----------------------------------------------------------------------------
`timescale 1ns/100ps
module code_gen_s2(data,code_in, code_out);
    input [9:0] data;
    input [31:0] code_in;
    output [31:0] code_out;

assign code_out[0] = code_in[0] ^ data[9] ^ data[8] ^ data[7] ^ data[6] ^ data[5] ^ data[4] ^ data[3] ^ data[2] ^ data[1] ^ data[0];
assign code_out[1] = code_in[1] ^ data[5] ^ data[4] ^ data[3] ^ data[2] ^ data[1] ^ data[0];
assign code_out[2] = code_in[2] ^ data[8] ^ data[7] ^ data[6] ^ data[2] ^ data[1] ^ data[0];
assign code_out[3] = code_in[3] ^ data[2] ^ data[1] ^ data[0];
assign code_out[4] = code_in[4] ^ data[9] ^ data[7] ^ data[6] ^ data[4] ^ data[3] ^ data[0];
assign code_out[5] = code_in[5] ^ data[4] ^ data[3] ^ data[0];
assign code_out[6] =  code_in[6] ^ data[7] ^ data[6] ^ data[0];
assign code_out[7] = code_in[7] ^ data[0];
assign code_out[8] = code_in[8] ^ data[9] ^ data[8] ^ data[6] ^  data[5] ^ data[3] ^ data[1];
assign code_out[9] = code_in[9] ^ data[5] ^ data[3] ^ data[1];
assign code_out[10] = code_in[10] ^ data[8] ^ data[6] ^ data[1];
assign code_out[11] = code_in[11] ^ data[1];
assign code_out[12] = code_in[12] ^ data[9] ^ data[6] ^ data[3];
assign code_out[13] = code_in[13] ^ data[3];
assign code_out[14] = code_in[14] ^ data[6];
assign code_out[15] = code_in[15] ;
assign code_out[16] = code_in[16] ^ data[9] ^ data[8] ^ data[7] ^  data[5] ^ data[4] ^ data[2];
assign code_out[17] = code_in[17] ^ data[5] ^ data[4] ^ data[2];
assign code_out[18] = code_in[18] ^ data[8] ^ data[7] ^ data[2];
assign code_out[19] = code_in[19] ^ data[2];
assign code_out[20] = code_in[20] ^ data[9] ^ data[7] ^ data[4];
assign code_out[21] = code_in[21] ^  data[4];
assign code_out[22] = code_in[22] ^  data[7];
assign code_out[23] = code_in[23] ;
assign code_out[24] = code_in[24] ^ data[9] ^ data[8] ^ data[5];
assign code_out[25] = code_in[25] ^ data[5];
assign code_out[26] = code_in[26] ^ data[8];
assign code_out[27] = code_in[27] ;
assign code_out[28] = code_in[28] ^  data[9];
assign code_out[29] = code_in[29] ;
assign code_out[30] = code_in[30] ;
assign code_out[31] = code_in[31] ;

endmodule
