//-----------------------------------------------------------------------------
// code_gen_s3 - Module
//-----------------------------------------------------------------------------
//**************************************************************************
// 
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION \"AS IS\"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//**************************************************************************
//-----------------------------------------------------------------------------
// Filename:        code_gen_s3.v
//-----------------------------------------------------------------------------
// Description:
//      Top level design for 16-bit Multiple Error Detection and Correction.
//		  Further details can be found in XAPP715
//-----------------------------------------------------------------------------
//Structure:
//      --XAPP715_top.v
//        |--code_gen_s2.v
//        |--code_gen_s3.v
//        |--MLD_s1.v
//           |--MLD_adder_s1.v
//        |--MLD_s2.v
//           |--MLD_adder_s2.v
//        |--MLD_s3.v
//        |--ocs_gen_s1.v
//        |--ocs_gen_s2.v
//        |--encoder.v
//
//-----------------------------------------------------------------------------
// Owners:          Simon Tam 
// Revision 1.0
//
//     Modification History:                                                   
//     Date     Init          Description                                
//   --------  ------ ---------------------------------------------------------    
//   11/9/2004    STAM	    Initial Release 
//-----------------------------------------------------------------------------
`timescale 1ns/100ps
module code_gen_s3(datain,code_in, code_out);
    input [4:0] datain;
    input [31:0] code_in;
    output [31:0] code_out;

wire [14:10] data;

assign data = datain;
assign code_out[0] = code_in[0] ^ data[14] ^ data[13] ^ data[12] ^ data[11] ^ data[10];
assign code_out[1] = code_in[1]            ^ data[13] ^ data[12] ^ data[11] ^ data[10];
assign code_out[2] = code_in[2] ^ data[14]            ^ data[12] ^ data[11] ^ data[10];
assign code_out[3] = code_in[3]                       ^ data[12] ^ data[11] ^ data[10];
assign code_out[4] = code_in[4] ^ data[14] ^ data[13]            ^ data[11] ^ data[10];
assign code_out[5] = code_in[5]            ^ data[13]            ^ data[11] ^ data[10];
assign code_out[6] = code_in[6] ^ data[14]                       ^ data[11] ^ data[10];
assign code_out[7] = code_in[7]                                  ^ data[11] ^ data[10];
assign code_out[8] = code_in[8] ^ data[14] ^ data[13] ^ data[12]            ^ data[10];
assign code_out[9] = code_in[9]            ^ data[13] ^ data[12]            ^ data[10];
assign code_out[10] = code_in[10] ^ data[14]          ^ data[12]            ^ data[10];
assign code_out[11] = code_in[11]                     ^ data[12]            ^ data[10];
assign code_out[12] = code_in[12] ^ data[14] ^ data[13]                     ^ data[10];
assign code_out[13] = code_in[13]            ^ data[13]                     ^ data[10];
assign code_out[14] = code_in[14] ^ data[14]                                ^ data[10];
assign code_out[15] = code_in[15]                                           ^ data[10];
assign code_out[16] = code_in[16] ^ data[14] ^ data[13] ^ data[12] ^ data[11];
assign code_out[17] = code_in[17]            ^ data[13] ^ data[12] ^ data[11];
assign code_out[18] = code_in[18] ^ data[14]            ^ data[12] ^ data[11];
assign code_out[19] = code_in[19]                       ^ data[12] ^ data[11];
assign code_out[20] = code_in[20] ^ data[14] ^ data[13]            ^ data[11];
assign code_out[21] = code_in[21]            ^ data[13]            ^ data[11];
assign code_out[22] = code_in[22] ^ data[14]                       ^ data[11];
assign code_out[23] = code_in[23]                                  ^ data[11];
assign code_out[24] = code_in[24] ^ data[14] ^ data[13] ^ data[12];
assign code_out[25] = code_in[25]            ^ data[13] ^ data[12];
assign code_out[26] = code_in[26] ^ data[14]            ^ data[12];
assign code_out[27] = code_in[27]                       ^ data[12];
assign code_out[28] = code_in[28] ^ data[14] ^ data[13];
assign code_out[29] = code_in[29]            ^ data[13];
assign code_out[30] = code_in[30] ^ data[14];
assign code_out[31] = code_in[31];

endmodule
